'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRelatedTypes = getRelatedTypes;


function getNamedTypeNode(typeNode) {
  let unmodifiedTypeNode = typeNode;
  while (unmodifiedTypeNode.kind === 'ListType' || unmodifiedTypeNode.kind === 'NonNullType') {
    unmodifiedTypeNode = unmodifiedTypeNode.type;
  }
  return unmodifiedTypeNode;
}

function getRelatedTypes(documentNode) {
  let types = [];
  documentNode.definitions.forEach(definition => {
    if (definition.kind === 'TypeExtensionDefinition' && definition.definition) {
      types = types.concat(definition.definition.fields.map(field => {
        if (field.type) {
          const namedTypeNode = getNamedTypeNode(field.type);
          return namedTypeNode.name.value;
        }
        return null;
      }));
    }
  });
  return types;
}